3 # Copyright (C) 2012-2013 Brian Aker
6 # Redistribution and use in source and binary forms, with or without
7 # modification, are permitted provided that the following conditions are
10 # * Redistributions of source code must retain the above copyright
11 # notice, this list of conditions and the following disclaimer.
13 # * Redistributions in binary form must reproduce the above
14 # copyright notice, this list of conditions and the following disclaimer
15 # in the documentation and/or other materials provided with the
18 # * The names of its contributors may not be used to endorse or
19 # promote products derived from this software without specific prior
22 # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
23 # "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
24 # LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
25 # A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
26 # OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
27 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
28 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
29 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
30 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
31 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
32 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
35 # Environment Variables that will influence the build:
46 command_not_found_handle
()
48 warn
"$@: command not found"
54 while caller
$frame; do
65 echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
70 echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
76 echo "$BASH_SOURCE:$BASH_LINENO: $@"
77 #echo "$BASH_SOURCE:$BASH_LINENO: $@" >&1
82 local param_name
=\$
"$1"
83 local param_value
=`eval "expr \"$param_name\" "`
85 if [ -n "$param_value" ]; then
86 echo "$bash_source:$bash_lineno: assert($param_name) had value of "$param_value"" >&2
93 local param_name
=\$
"$1"
94 local param_value
=`eval "expr \"$param_name\" "`
96 if [ -z "$param_value" ]; then
97 echo "$bash_source:$bash_lineno: assert($param_name)" >&2
102 function assert_file
()
104 if [ ! -f "$1" ]; then
105 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
110 function assert_no_file
()
113 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) file exists: $2" >&2
118 function assert_no_directory
()
121 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) directory exists: $2" >&2
126 function assert_exec_file
()
128 if [ ! -f "$1" ]; then
129 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
133 if [ ! -x "$1" ]; then
134 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) exists but is not executable: $2" >&2
139 function command_exists
()
141 type "$1" &> /dev
/null
;
144 function rebuild_host_os
()
146 HOST_OS
="${UNAME_MACHINE_ARCH}-${VENDOR}-${VENDOR_DISTRIBUTION}-${VENDOR_RELEASE}-${UNAME_KERNEL}-${UNAME_KERNEL_RELEASE}"
149 echo "HOST_OS=$HOST_OS"
154 # Validate the distribution name, or toss an erro
155 # values: darwin,fedora,rhel,ubuntu,debian,opensuse
156 function set_VENDOR_DISTRIBUTION
()
158 local dist
=`echo "$1" | tr '[A-Z]' '[a-z]'`
161 VENDOR_DISTRIBUTION
='darwin'
164 VENDOR_DISTRIBUTION
='fedora'
167 VENDOR_DISTRIBUTION
='rhel'
170 VENDOR_DISTRIBUTION
='debian'
173 VENDOR_DISTRIBUTION
='ubuntu'
176 VENDOR_DISTRIBUTION
='opensuse'
179 VENDOR_DISTRIBUTION
='opensuse'
182 die
"attempt to set an invalid VENDOR_DISTRIBUTION=$dist"
187 # Validate a Vendor's release name/number
188 function set_VENDOR_RELEASE
()
190 local release
=`echo "$1" | tr '[A-Z]' '[a-z]'`
191 case "$VENDOR_DISTRIBUTION" in
193 case "$VENDOR_DISTRIBUTION" in
195 VENDOR_RELEASE
='snow_leopard'
198 VENDOR_RELEASE
='mountain'
201 VENDOR_RELEASE
='mountain'
204 VENDOR_RELEASE
='mountain_lion'
207 VENDOR_RELEASE
='unknown'
212 VENDOR_RELEASE
="$release"
213 if [[ "x$VENDOR_RELEASE" == '18' ]]; then
214 VENDOR_RELEASE
='sphericalcow'
218 VENDOR_RELEASE
="$release"
221 VENDOR_RELEASE
="$release"
224 VENDOR_RELEASE
="$release"
225 if [[ "x$VENDOR_RELEASE" == 'x12.04' ]]; then
226 VENDOR_RELEASE
="precise"
227 elif [[ "x$VENDOR_RELEASE" == 'x12.10' ]]; then
228 VENDOR_RELEASE
="quantal"
232 VENDOR_RELEASE
="$release"
235 die
"attempt to set VENDOR_RELEASE without setting VENDOR_DISTRIBUTION"
238 die
"attempt to set with an invalid VENDOR_DISTRIBUTION=$VENDOR_DISTRIBUTION"
244 # Valid values are: apple, redhat, centos, canonical, oracle, suse
245 function set_VENDOR
()
247 local vendor
=`echo "$1" | tr '[A-Z]' '[a-z]'`
259 redhat-release-server-
*)
262 enterprise-release-
*)
284 die
"An attempt was made to set an invalid VENDOR=$_vendor"
288 set_VENDOR_DISTRIBUTION
$2
289 set_VENDOR_RELEASE
$3
291 # Set which vendor/versions we trust for autoreconf
292 case $VENDOR_DISTRIBUTION in
294 if [[ "x$VENDOR_RELEASE" == 'x18' ]]; then
295 AUTORECONF_REBUILD_HOST
=true
296 elif [[ "x$VENDOR_RELEASE" == 'xsphericalcow' ]]; then
297 AUTORECONF_REBUILD_HOST
=true
298 elif [[ "x$VENDOR_RELEASE" == 'x19' ]]; then
299 AUTORECONF_REBUILD_HOST
=true
303 if [[ "x$VENDOR_RELEASE" == 'xprecise' ]]; then
304 AUTORECONF_REBUILD_HOST
=true
305 elif [[ "x$VENDOR_RELEASE" == 'xquantal' ]]; then
306 AUTORECONF_REBUILD_HOST
=true
313 function determine_target_platform
()
315 UNAME_MACHINE_ARCH
=`(uname -m) 2>/dev/null` || UNAME_MACHINE_ARCH
=unknown
316 UNAME_KERNEL
=`(uname -s) 2>/dev/null` || UNAME_SYSTEM
=unknown
317 UNAME_KERNEL_RELEASE
=`(uname -r) 2>/dev/null` || UNAME_KERNEL_RELEASE
=unknown
319 if [[ -x '/usr/bin/sw_vers' ]]; then
320 local _VERSION
=`/usr/bin/sw_vers -productVersion`
321 set_VENDOR
'apple' 'darwin' $_VERSION
322 elif [[ $
(uname
) == 'Darwin' ]]; then
323 set_VENDOR
'apple' 'darwin' 'mountain'
324 elif [[ -f '/etc/fedora-release' ]]; then
325 local fedora_version
=`cat /etc/fedora-release | awk ' { print $3 } '`
326 set_VENDOR
'redhat' 'fedora' $fedora_version
327 elif [[ -f '/etc/centos-release' ]]; then
328 local centos_version
=`cat /etc/centos-release | awk ' { print $7 } '`
329 set_VENDOR
'centos' 'rhel' $centos_version
330 elif [[ -f '/etc/SuSE-release' ]]; then
331 local suse_distribution
=`head -1 /etc/SuSE-release | awk ' { print $1 } '`
332 local suse_version
=`head -1 /etc/SuSE-release | awk ' { print $2 } '`
333 set_VENDOR
'suse' $suse_distribution $suse_version
334 elif [[ -f '/etc/redhat-release' ]]; then
335 local rhel_version
=`cat /etc/redhat-release | awk ' { print $7 } '`
336 local _vendor
=`rpm -qf /etc/redhat-release`
337 set_VENDOR
$_vendor 'rhel' $rhel_version
338 elif [[ -f '/etc/os-release' ]]; then
339 source '/etc/os-release'
340 set_VENDOR
$ID $ID $VERSION_ID
341 elif [[ -x '/usr/bin/lsb_release' ]]; then
342 local _ID
=`/usr/bin/lsb_release -s -i`
343 local _VERSION
=`/usr/bin/lsb_release -s -r`
344 set_VENDOR
$_ID $_ID $_VERSION_ID
345 elif [[ -f '/etc/lsb-release' ]]; then
346 source '/etc/lsb-release'
347 set_VENDOR
'canonical' $DISTRIB_ID $DISTRIB_CODENAME
353 function run_configure
()
355 # We will run autoreconf if we are required
356 run_autoreconf_if_required
358 # We always begin at the root of our build
360 die
"Programmer error, we entered run_configure with a stacked directory"
363 if ! command_exists
"$CONFIGURE"; then
364 die
"$CONFIGURE does not exist"
368 if [[ -n "$BUILD_DIR" ]]; then
371 safe_pushd
$BUILD_DIR
374 # Arguments for configure
375 local BUILD_CONFIGURE_ARG
=
377 # If ENV DEBUG is set we enable both debug and asssert, otherwise we see if this is a VCS checkout and if so enable assert
378 # Set ENV ASSERT in order to enable assert
380 BUILD_CONFIGURE_ARG
+=' --enable-debug --enable-assert'
381 elif [[ -n "$VCS_CHECKOUT" ]]; then
382 BUILD_CONFIGURE_ARG
+=' --enable-assert'
385 if [[ -n "$CONFIGURE_ARG" ]]; then
386 BUILD_CONFIGURE_ARG
+=" $CONFIGURE_ARG"
389 if [[ -n "$PREFIX_ARG" ]]; then
390 BUILD_CONFIGURE_ARG
+=" $PREFIX_ARG"
394 # If we are executing on OSX use CLANG, otherwise only use it if we find it in the ENV
397 CC
=clang CXX
=clang
++ $top_srcdir/configure
$BUILD_CONFIGURE_ARG || die
"Cannot execute CC=clang CXX=clang++ configure $BUILD_CONFIGURE_ARG"
401 command_exists
'gcc44' || die
"Could not locate gcc44"
402 CC
=gcc44 CXX
=gcc44
$top_srcdir/configure
$BUILD_CONFIGURE_ARG || die
"Cannot execute CC=gcc44 CXX=gcc44 configure $BUILD_CONFIGURE_ARG"
406 $CONFIGURE $BUILD_CONFIGURE_ARG
411 if [ $ret -ne 0 ]; then
412 die
"Could not execute $CONFIGURE $BUILD_CONFIGURE_ARG"
415 if [ ! -f 'Makefile' ]; then
416 die
"Programmer error, configure was run but no Makefile existed after $CONFIGURE was run"
420 function setup_gdb_command
() {
421 GDB_TMPFILE
=$
(mktemp
/tmp
/gdb.XXXXXXXXXX
)
422 echo 'set logging overwrite on' > $GDB_TMPFILE
423 echo 'set logging on' >> $GDB_TMPFILE
424 echo 'set environment LIBTEST_IN_GDB=1' >> $GDB_TMPFILE
425 echo 'run' >> $GDB_TMPFILE
426 echo 'thread apply all bt' >> $GDB_TMPFILE
427 echo 'quit' >> $GDB_TMPFILE
428 GDB_COMMAND
="gdb -f -batch -x $GDB_TMPFILE"
431 function setup_valgrind_command
() {
432 VALGRIND_PROGRAM
=`type -p valgrind`
433 if [[ -n "$VALGRIND_PROGRAM" ]]; then
434 VALGRIND_COMMAND
="$VALGRIND_PROGRAM --error-exitcode=1 --leak-check=yes --show-reachable=yes --track-fds=yes --malloc-fill=A5 --free-fill=DE"
438 function save_BUILD
()
440 if [[ -n "$OLD_CONFIGURE" ]]; then
441 die
"OLD_CONFIGURE($OLD_CONFIGURE) was set on push, programmer error!"
444 if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
445 die
"OLD_CONFIGURE_ARG($OLD_CONFIGURE_ARG) was set on push, programmer error!"
448 if [[ -n "$OLD_PREFIX" ]]; then
449 die
"OLD_PREFIX($OLD_PREFIX) was set on push, programmer error!"
452 if [[ -n "$OLD_MAKE" ]]; then
453 die
"OLD_MAKE($OLD_MAKE) was set on push, programmer error!"
456 if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
457 die
"OLD_TESTS_ENVIRONMENT($OLD_TESTS_ENVIRONMENT) was set on push, programmer error!"
460 if [[ -n "$CONFIGURE" ]]; then
461 OLD_CONFIGURE
=$CONFIGURE
464 if [[ -n "$CONFIGURE_ARG" ]]; then
465 OLD_CONFIGURE_ARG
=$CONFIGURE_ARG
468 if [[ -n "$MAKE" ]]; then
472 if [[ -n "$TESTS_ENVIRONMENT" ]]; then
473 OLD_TESTS_ENVIRONMENT
=$TESTS_ENVIRONMENT
477 function restore_BUILD
()
479 if [[ -n "$OLD_CONFIGURE" ]]; then
480 CONFIGURE
=$OLD_CONFIGURE
483 if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
484 CONFIGURE_ARG
=$OLD_CONFIGURE_ARG
487 if [[ -n "$OLD_PREFIX" ]]; then
488 PREFIX_ARG
=$OLD_PREFIX
491 if [[ -n "$OLD_MAKE" ]]; then
495 if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
496 TESTS_ENVIRONMENT
=$OLD_TESTS_ENVIRONMENT
503 OLD_TESTS_ENVIRONMENT
=
508 function safe_pushd
()
510 pushd $1 &> /dev
/null
;
512 if [ -n "$BUILD_DIR" ]; then
514 echo "BUILD_DIR=$BUILD_DIR"
519 function safe_popd
()
521 local directory_to_delete
=`pwd`
523 if [ $?
-eq 0 ]; then
524 if [[ "$top_srcdir" == "$directory_to_delete" ]]; then
525 die
"We almost deleted top_srcdir($top_srcdir), programmer error"
528 rm -r -f "$directory_to_delete"
532 function make_valgrind
()
534 if [[ "$VENDOR_DISTRIBUTION" == 'darwin' ]]; then
539 # If the env VALGRIND_COMMAND is set then we assume it is valid
540 local valgrind_was_set
=false
541 if [[ -z "$VALGRIND_COMMAND" ]]; then
542 setup_valgrind_command
543 if [[ -n "$VALGRIND_COMMAND" ]]; then
544 valgrind_was_set
=true
547 valgrind_was_set
=true
550 # If valgrind_was_set is set to no we bail
551 if ! $valgrind_was_set; then
552 echo 'valgrind was not present'
558 # If we are required to run configure, do so now
559 run_configure_if_required
561 # If we don't have a configure, then most likely we will be missing libtool
562 assert_file
'configure'
563 if [[ -f 'libtool' ]]; then
564 TESTS_ENVIRONMENT
="./libtool --mode=execute $VALGRIND_COMMAND"
566 TESTS_ENVIRONMENT
="$VALGRIND_COMMAND"
569 make_target
'check' ||
return 1
574 function make_install_system
()
576 local INSTALL_LOCATION
=$
(mktemp
-d /tmp
/XXXXXXXXXX
)
579 PREFIX_ARG
="--prefix=$INSTALL_LOCATION"
581 if [ ! -d $INSTALL_LOCATION ] ; then
582 die
"ASSERT temp directory not found '$INSTALL_LOCATION'"
585 run_configure
#install_buid_dir
587 make_target
'install'
589 make_target
'installcheck'
591 make_target
'uninstall'
593 rm -r -f $INSTALL_LOCATION
596 if [ -f 'Makefile' ]; then
597 die
"ASSERT Makefile should not exist"
604 function make_darwin_malloc
()
606 run_configure_if_required
608 old_MallocGuardEdges
=$MallocGuardEdges
610 old_MallocErrorAbort
=$MallocErrorAbort
612 old_MallocScribble
=$MallocScribble
617 MallocGuardEdges
=$old_MallocGuardEdges
618 MallocErrorAbort
=$old_MallocErrorAbort
619 MallocScribble
=$old_MallocScribble
622 function snapshot_check
()
624 if [ ! -f "$BOOTSTRAP_SNAPSHOT_CHECK" ]; then
628 if [ -n "$BOOTSTRAP_SNAPSHOT_CHECK" ]; then
629 assert_file
"$BOOTSTRAP_SNAPSHOT_CHECK" 'snapshot check failed'
633 # This will reset our environment, and make sure built files are available.
634 function make_for_snapshot
()
636 # Make sure it is clean
637 make_maintainer_clean
641 make_target
'distclean'
643 # We should have a configure, but no Makefile at the end of this exercise
644 assert_no_file
'Makefile'
645 assert_exec_file
'configure'
650 function check_mingw
()
652 command_exists
'mingw64-configure'
654 if [ "$ret" -ne 0 ]; then
658 command_exists
'mingw64-make'
660 if [ "$ret" -ne 0 ]; then
667 function check_clang
()
669 command_exists
'clang'
671 if [ "$ret" -ne 0 ]; then
678 function check_clang_analyzer
()
680 command_exists
'scan-build'
682 if [ "$ret" -ne 0 ]; then
689 function make_skeleton
()
694 if [ $ret -eq 0 ]; then
695 assert_file
'Makefile'
697 make_target
'all' 'warn'
699 if [ $ret -ne 0 ]; then
702 if [[ -n "$DISPLAY" ]]; then
703 if command_exists
'wine'; then
704 TESTS_ENVIRONMENT
='wine'
708 if [[ -n "$TESTS_ENVIRONMENT" ]]; then
709 make_target
'check' 'warn' || warn
"$MAKE check failed"
714 if $jenkins_build_environment; then
715 make_target
'clean' 'warn'
722 function make_for_mingw
()
724 if ! check_mingw
; then
728 # Make sure it is clean
729 if [ -f Makefile
-o -f configure
]; then
730 make_maintainer_clean
737 CONFIGURE
='mingw64-configure'
739 CONFIGURE_ARGS
='--enable-static --disable-shared'
749 function make_for_clang
()
751 if ! check_clang
; then
755 # Make sure it is clean
756 if [ -f Makefile
-o -f configure
]; then
757 make_maintainer_clean
777 function make_for_clang_analyzer
()
779 if ! check_clang
; then
783 if ! check_clang_analyzer
; then
784 die
'clang-analyzer was not found'
787 # Make sure it is clean
788 if [ -f Makefile
-o -f configure
]; then
789 make_maintainer_clean
798 CONFIGURE_ARGS
='--enable-debug'
803 make_target
'clean' 'warn'
805 scan-build
-o clang-html
make -j4 -k
812 # If we are locally testing, we should make sure the environment is setup correctly
813 function check_for_jenkins
()
815 if ! $jenkins_build_environment; then
816 echo "Not inside of jenkins"
818 if [ -f 'configure' ]; then
819 make_maintainer_clean
822 if $BOOTSTRAP_SNAPSHOT; then
828 function make_universe
()
835 make_for_clang_analyzer
837 if [ check_mingw
-eq 0 ]; then
845 function make_for_continuus_integration
()
847 # Setup the environment if we are local
850 # No matter then evironment, we should not have a Makefile at this point
851 assert_no_file
'Makefile'
853 # Platforms which require bootstrap should have some setup done before we hit this stage.
854 # If we are building locally, skip this step, unless we are just testing locally.
855 if $BOOTSTRAP_SNAPSHOT; then
858 # If we didn't require a snapshot, then we should not have a configure
859 assert_no_file
'configure'
864 assert_no_file
'Makefile' 'Programmer error, Makefile existed where build state should have been clean'
870 assert_exec_file
'configure'
871 assert_file
'Makefile'
875 # make rpm includes "make distcheck"
876 if [[ -f rpm.am
]]; then
878 elif [[ -d rpm
]]; then
884 assert_exec_file
'configure'
885 assert_file
'Makefile'
892 assert_exec_file
'configure'
893 assert_file
'Makefile'
899 assert_exec_file
'configure'
900 assert_file
'Makefile'
904 assert_exec_file
'configure'
905 assert_file
'Makefile'
914 make_maintainer_clean
919 # The point to this test is to test bootstrap.sh itself
920 function self_test
()
922 # We start off with a clean env
923 make_maintainer_clean
925 eval "./bootstrap.sh jenkins" || die
"failed 'jenkins'"
926 eval "./bootstrap.sh all" || die
"failed 'all'"
927 eval "./bootstrap.sh gdb" || die
"failed 'gdb'"
928 eval "./bootstrap.sh maintainer-clean" || die
"failed 'maintainer-clean'"
931 function make_install_html
()
933 run_configure_if_required
934 assert_file
'configure'
936 make_target
'install-html'
943 if command_exists
'gdb'; then
944 run_configure_if_required
946 # Set ENV GDB_COMMAND
947 if [[ -z "$GDB_COMMAND" ]]; then
951 # If we don't have a configure, then most likely we will be missing libtool
952 assert_file
'configure'
953 if [[ -f 'libtool' ]]; then
954 TESTS_ENVIRONMENT
="./libtool --mode=execute $GDB_COMMAND"
956 TESTS_ENVIRONMENT
="$GDB_COMMAND"
961 if [ -f 'gdb.txt' ]; then
965 if [ -f '.gdb_history' ]; then
969 if $jenkins_build_environment; then
973 echo 'gdb was not present'
980 # $1 target to compile
981 # $2 to die, or not to die, based on contents
982 function make_target
()
985 die
"Programmer error, no target provided for make"
988 if [ ! -f 'Makefile' ]; then
989 die
"Programmer error, make was called before configure"
993 if [ -n "$TESTS_ENVIRONMENT" ]; then
995 echo "TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT"
999 if [ -z "$MAKE" ]; then
1000 die
"MAKE was not set"
1003 # $2 represents error or warn
1007 if [ $ret -ne 0 ]; then
1008 if [ -n "$2" ]; then
1009 warn
"Failed to execute $MAKE $1: $ret"
1011 die
"Failed to execute $MAKE $1: $ret"
1018 function make_distcheck
()
1020 make_target
'distcheck'
1023 function make_rpm
()
1025 if command_exists
'rpmbuild'; then
1026 if [ -f 'rpm.am' -o -d 'rpm' ]; then
1027 run_configure_if_required
1030 if $jenkins_build_environment; then
1038 function make_maintainer_clean
()
1040 run_configure_if_required
1041 make_target
'maintainer-clean' 'no_error'
1043 # Lets make sure we really cleaned up the environment
1044 assert_no_file
'Makefile'
1045 assert_no_file
'configure'
1046 assert_no_directory
'autom4te.cache'
1049 function make_check
()
1054 function make_jenkins_default
()
1060 function make_default
()
1062 run_configure_if_required
1066 function run_configure_if_required
()
1068 run_autoreconf_if_required
1070 if [ ! -f 'Makefile' ]; then
1074 assert_file
'Makefile' 'configure did not produce a Makefile'
1077 function run_make_maintainer_clean_if_possible
()
1079 if [ -f 'Makefile' ]; then
1080 make_maintainer_clean
1084 function run_autoreconf_if_required
()
1086 if [ ! -x 'configure' ]; then
1090 assert_exec_file
'configure'
1094 function run_autoreconf
()
1096 if [[ -z "$AUTORECONF" ]]; then
1097 die
"Programmer error, tried to call run_autoreconf () but AUTORECONF was not set"
1100 if test $use_libtool = 1; then
1101 assert
$BOOTSTRAP_LIBTOOLIZE
1102 run
$BOOTSTRAP_LIBTOOLIZE '--copy' '--install' '--force' || die
"Cannot execute $BOOTSTRAP_LIBTOOLIZE"
1105 run
$AUTORECONF || die
"Cannot execute $AUTORECONF"
1107 eval 'bash -n configure' || die
"autoreconf generated a malformed configure"
1116 if [ -z "$1" ]; then
1123 function parse_command_line_options
()
1125 local SHORTOPTS
=':apcmt:dvh'
1129 while getopts "$SHORTOPTS" opt
; do
1132 AUTORECONF_OPTION
=true
1133 MAKE_TARGET
='autoreconf'
1136 PRINT_SETUP_OPTION
=true
1139 CONFIGURE_OPTION
=true
1140 MAKE_TARGET
='configure'
1142 m
) # maintainer-clean
1144 MAKE_TARGET
='clean_op'
1148 TARGET_OPTION_ARG
="$OPTARG"
1149 MAKE_TARGET
="$OPTARG"
1156 echo "bootstrap.sh [options] optional_target ..."
1157 echo " -a # Just run autoreconf";
1158 echo " -p # Print ENV";
1159 echo " -c # Just run configure";
1160 echo " -m # Just run maintainer-clean";
1161 echo " -t # Make target";
1162 echo " -d # Enable debug";
1163 echo " -h # Show help";
1164 echo " -v # Be more verbose in output";
1172 echo "Option -$OPTARG requires an argument." >&2
1176 echo "$0: error - unrecognized option $1" 1>&2
1184 if [ -n "$1" ]; then
1189 function determine_vcs
()
1191 if [[ -d '.git' ]]; then
1193 elif [[ -d '.bzr' ]]; then
1195 elif [[ -d '.svn' ]]; then
1197 elif [[ -d '.hg' ]]; then
1203 if [[ -n "$VCS_CHECKOUT" ]]; then
1208 function require_libtoolise
()
1211 grep '^[ ]*A[CM]_PROG_LIBTOOL' configure.ac
>/dev
/null \
1213 grep '^[ ]*LT_INIT' configure.ac
>/dev
/null \
1217 function autoreconf_setup
()
1219 # Set ENV MAKE in order to override "make"
1220 if [[ -z "$MAKE" ]]; then
1221 if command_exists
'gmake'; then
1222 MAKE
=`type -p gmake`
1224 if command_exists
'make'; then
1229 if [ "$VCS_CHECKOUT" ]; then
1231 MAKE
="$MAKE --warn-undefined-variables"
1240 if [[ -z "$GNU_BUILD_FLAGS" ]]; then
1241 GNU_BUILD_FLAGS
="--install --force"
1245 GNU_BUILD_FLAGS
="$GNU_BUILD_FLAGS --verbose"
1248 if [ -z "$ACLOCAL_PATH" ]; then
1249 ACLOCAL_PATH
="/usr/local/share/aclocal $ACLOCAL_PATH"
1252 if [[ -z "$WARNINGS" ]]; then
1253 if [[ -n "$VCS_CHECKOUT" ]]; then
1254 WARNINGS
="all,error"
1260 if test $use_libtool = 1; then
1261 if [[ -n "$LIBTOOLIZE" ]]; then
1262 BOOTSTRAP_LIBTOOLIZE
=`type -p $LIBTOOLIZE`
1264 if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
1265 echo "Couldn't find user supplied libtoolize, it is required"
1269 # If we are using OSX, we first check to see glibtoolize is available
1270 if [[ "$VENDOR_DISTRIBUTION" == "darwin" ]]; then
1271 BOOTSTRAP_LIBTOOLIZE
=`type -p glibtoolize`
1273 if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
1274 echo "Couldn't find glibtoolize, it is required on OSX"
1278 BOOTSTRAP_LIBTOOLIZE
=`type -p libtoolize`
1280 if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
1281 echo "Couldn't find libtoolize, it is required"
1287 LIBTOOLIZE_OPTIONS
="--verbose $BOOTSTRAP_LIBTOOLIZE_OPTIONS"
1290 LIBTOOLIZE_OPTIONS
="--debug $BOOTSTRAP_LIBTOOLIZE_OPTIONS"
1295 # Test the ENV AUTOMAKE if it exists
1296 if [[ -n "$AUTOMAKE" ]]; then
1297 run
$AUTOMAKE '--help' &> /dev
/null || die
"Failed to run AUTOMAKE:$AUTOMAKE"
1300 # Test the ENV AUTOCONF if it exists
1301 if [[ -n "$AUTOCONF" ]]; then
1302 run
$AUTOCONF '--help' &> /dev
/null || die
"Failed to run AUTOCONF:$AUTOCONF"
1305 # Test the ENV AUTOHEADER if it exists
1306 if [[ -n "$AUTOHEADER" ]]; then
1307 run
$AUTOHEADER '--help' &> /dev
/null || die
"Failed to run AUTOHEADER:$AUTOHEADER"
1310 # Test the ENV AUTOM4TE if it exists
1311 if [[ -n "$AUTOM4TE" ]]; then
1312 run
$AUTOM4TE '--help' &> /dev
/null || die
"Failed to run AUTOM4TE:$AUTOM4TE"
1315 # Test the ENV AUTOHEADER if it exists, if not we add one and add --install
1316 if [[ -z "$ACLOCAL" ]]; then
1317 ACLOCAL
="aclocal --install"
1319 run
$ACLOCAL '--help' &> /dev
/null || die
"Failed to run ACLOCAL:$ACLOCAL"
1321 if [[ -z "$AUTORECONF" ]]; then
1322 AUTORECONF
=`type -p autoreconf`
1324 if [[ -z "$AUTORECONF" ]]; then
1325 die
"Couldn't find autoreconf"
1328 if [[ -n "$GNU_BUILD_FLAGS" ]]; then
1329 AUTORECONF
="$AUTORECONF $GNU_BUILD_FLAGS"
1333 run
$AUTORECONF '--help' &> /dev
/null || die
"Failed to run AUTORECONF:$AUTORECONF"
1336 function print_setup
()
1338 saved_debug_status
=$DEBUG
1343 echo '----------------------------------------------'
1344 echo 'BOOTSTRAP ENV'
1345 echo "AUTORECONF=$AUTORECONF"
1346 echo "HOST_OS=$HOST_OS"
1347 echo "VENDOR=$VENDOR"
1348 echo "VENDOR_DISTRIBUTION=$VENDOR_DISTRIBUTION"
1349 echo "VENDOR_RELEASE=$VENDOR_RELEASE"
1352 if $AUTORECONF_OPTION; then
1356 if $CLEAN_OPTION; then
1360 if $CONFIGURE_OPTION; then
1364 if $DEBUG_OPTION; then
1368 if $PRINT_SETUP_OPTION; then
1372 if $TARGET_OPTION; then
1373 echo "--target=$TARGET_OPTION_ARG"
1376 if $VERBOSE_OPTION; then
1380 if [[ -n "$MAKE" ]]; then
1384 if [[ -n "$MAKE_TARGET" ]]; then
1385 echo "MAKE_TARGET=$MAKE_TARGET"
1388 if [[ -n "$PREFIX" ]]; then
1389 echo "PREFIX=$PREFIX"
1392 if [[ -n "$TESTS_ENVIRONMENT" ]]; then
1393 echo "TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT"
1396 if [[ -n "$VCS_CHECKOUT" ]]; then
1397 echo "VCS_CHECKOUT=$VCS_CHECKOUT"
1408 if [[ -n "$WARNINGS" ]]; then
1409 echo "WARNINGS=$WARNINGS"
1411 echo '----------------------------------------------'
1413 if $saved_debug_status; then
1418 function make_clean_option
()
1420 run_configure_if_required
1422 make_maintainer_clean
1424 if [[ "$VCS_CHECKOUT" == 'git' ]]; then
1425 run
"$VCS_CHECKOUT" status
--ignored
1426 elif [[ -n "$VCS_CHECKOUT" ]]; then
1427 run
"$VCS_CHECKOUT" status
1431 function make_for_autoreconf
()
1433 if [ -f 'Makefile' ]; then
1434 make_maintainer_clean
1439 assert_no_file
'Makefile'
1442 function check_make_target
()
1496 echo "Matched default"
1504 function bootstrap
()
1506 determine_target_platform
1510 # Set up whatever we need to do to use autoreconf later
1512 if ! autoreconf_setup
; then
1516 if [ -z "$MAKE_TARGET" ]; then
1517 MAKE_TARGET
="make_default"
1520 if $PRINT_SETUP_OPTION -o $DEBUG; then
1525 # Exit if all we were looking for were the currently used options
1526 if $PRINT_SETUP_OPTION; then
1531 # Use OLD_TESTS_ENVIRONMENT for tracking the state of the variable
1532 local OLD_TESTS_ENVIRONMENT
=
1534 # Set ENV PREFIX in order to set --prefix for ./configure
1535 if [[ -n "$PREFIX" ]]; then
1536 PREFIX_ARG
="--prefix=$PREFIX"
1539 # We should always have a target by this point
1542 local MAKE_TARGET_ARRAY
=($MAKE_TARGET)
1544 for target
in "${MAKE_TARGET_ARRAY[@]}"
1546 # If we are running inside of Jenkins, we want to only run some of the possible tests
1547 if $jenkins_build_environment; then
1548 check_make_target
$target
1550 if [ $ret -ne 0 ]; then
1551 die
"Unknown MAKE_TARGET option: $target"
1555 local snapshot_run
=false
1583 if ! check_clang
; then
1584 die
"clang was not found"
1587 if ! make_for_clang
; then
1588 die
"Failed to build clang: $?"
1592 if ! check_clang_analyzer
; then
1593 die
"clang-analyzer was not found"
1595 if ! check_clang
; then
1596 die
"clang was not found"
1599 if ! make_for_clang_analyzer
; then
1600 die
"Failed to build clang-analyzer: $?"
1604 if ! check_mingw
; then
1605 die
"mingw was not found"
1608 if ! make_for_mingw
; then
1609 die
"Failed to build mingw: $?"
1626 make_for_continuus_integration
1629 run_configure_if_required
1630 make_target
"$target"
1634 if $jenkins_build_environment; then
1635 if ! $snapshot_run; then
1636 run_make_maintainer_clean_if_possible
1645 # Variables we export
1646 declare -x VCS_CHECKOUT
=
1648 # Variables we control globally
1652 # Options for getopt
1653 local AUTORECONF_OPTION
=false
1654 local CLEAN_OPTION
=false
1655 local CONFIGURE_OPTION
=false
1656 local DEBUG_OPTION
=false
1657 local PRINT_SETUP_OPTION
=false
1658 local TARGET_OPTION
=false
1659 local TARGET_OPTION_ARG
=
1660 local VERBOSE_OPTION
=false
1662 local OLD_CONFIGURE
=
1663 local OLD_CONFIGURE_ARG
=
1666 local OLD_TESTS_ENVIRONMENT
=
1668 # If we call autoreconf on the platform or not
1669 local AUTORECONF_REBUILD_HOST
=false
1670 local AUTORECONF_REBUILD
=false
1672 local -r top_srcdir
=`pwd`
1675 if [ -z "$CONFIGURE" ]; then
1676 CONFIGURE
="$top_srcdir/configure"
1680 # Variables for determine_target_platform () and rebuild_host_os ()
1681 # UNAME_MACHINE_ARCH= uname -m
1682 # VENDOR= apple, redhat, centos, canonical
1684 # RHEL{rhel,Tikanga,Santiago}
1685 # Ubuntu{ubuntu,Lucid,Maverick,Natty,Oneiric,Precise,Quantal}
1686 # Fedora{fedora,Verne,Beefy}
1687 # OSX{osx,lion,snow,mountain}
1688 # VENDOR_DISTRIBUTION= darwin,fedora,rhel,ubuntu
1689 # UNAME_KERNEL= Linux, Darwin,...
1690 # UNAME_KERNEL_RELEASE= Linux, Darwin,...
1691 local UNAME_MACHINE_ARCH
=unknown
1692 local VENDOR
=unknown
1693 local VENDOR_RELEASE
=unknown
1694 local VENDOR_DISTRIBUTION
=unknown
1695 local UNAME_KERNEL
=unknown
1696 local UNAME_KERNEL_RELEASE
=unknown
1699 rebuild_host_os no_output
1701 parse_command_line_options $@
1703 # If we are running under Jenkins we predetermine what tests we will run against
1704 # This MAKE_TARGET can be overridden by parse_command_line_options based MAKE_TARGET changes.
1705 # We don't want Jenkins overriding other variables, so we NULL them.
1706 if [ -z "$MAKE_TARGET" ]; then
1707 if $jenkins_build_environment; then
1708 if [[ -n "$label" ]]; then
1709 check_make_target
$label
1710 if [ $?
-eq 0 ]; then
1711 MAKE_TARGET
="$label"
1715 if [ -z "$MAKE_TARGET" ]; then
1716 MAKE_TARGET
='jenkins'
1729 function set_branch
()
1731 if [ -z "$BRANCH" ]; then
1732 if [ -z "$CI_PROJECT_TEAM" ]; then
1733 die
"Variable CI_PROJECT_TEAM has not been set"
1735 if [ -z "$PROJECT" ]; then
1736 die
"Variable PROJECT has not been set"
1738 if [ -z "$BUILD_TAG" ]; then
1739 die
"Variable BUILD_TAG has not been set"
1742 BRANCH
="lp:~$CI_PROJECT_TEAM/$PROJECT/$BUILD_TAG"
1746 if [ -z "$BRANCH" ]; then
1747 die
"Missing values required to build BRANCH variable."
1753 if [ -z "$VCS_CHECKOUT" ]; then
1754 die
"Merges require VCS_CHECKOUT."
1759 if [[ "$VCS_CHECKOUT" == 'bzr' ]]; then
1760 if test -n "$BRANCH_TO_MERGE"; then
1761 bzr merge
$BRANCH_TO_MERGE
1762 bzr commit
--message="Merge $BRANCH_TO_MERGE Build: $BUILD_TAG" --unchanged
1766 elif [[ -n "$VCS_CHECKOUT" ]]; then
1767 die
"Merge attempt occured, current VCS setup does not support this"
1771 function enable_debug
()
1774 local caller_loc
=`caller`
1776 echo "$caller_loc Enabling debug: $1"
1778 echo "$caller_loc Enabling debug"
1788 Usage: $program_name [OPTION]..
1790 Bootstrap this package from the checked-out sources, and optionally walk through CI run.
1797 function disable_debug
()
1803 # Script begins here
1807 env_debug_enabled
=false
1808 if [[ -n "$JENKINS_HOME" ]]; then
1809 declare -r jenkins_build_environment
=true
1811 declare -r jenkins_build_environment
=false
1820 export CONFIGURE_ARG
1822 export GNU_BUILD_FLAGS
1824 export LIBTOOLIZE_OPTIONS
1827 export TESTS_ENVIRONMENT
1833 export MallocGuardEdges
1834 export MallocErrorAbort
1835 export MallocScribble
1839 # We check for DEBUG twice, once before we source the config file, and once afterward
1840 env_debug_enabled
=false
1841 if [[ -n "$DEBUG" ]]; then
1842 env_debug_enabled
=true
1847 # Variables which only can be set by .bootstrap
1848 BOOTSTRAP_SNAPSHOT
=false
1849 BOOTSTRAP_SNAPSHOT_CHECK
=
1851 if [ -f '.bootstrap' ]; then
1855 if $env_debug_enabled; then
1858 if [[ -n "$DEBUG" ]]; then
1859 enable_debug
"Enabling DEBUG from '.bootstrap'"
1864 # We do this in order to protect the case where DEBUG
1865 if ! $env_debug_enabled; then